# SPDX-FileCopyrightText: 2023 Alliander
#
# SPDX-License-Identifier: Apache-2.0

"""
Generated from the CGMES 3 files via cimgen: https://github.com/sogno-platform/cimgen
"""

from functools import cached_property
from typing import Optional

from pydantic import Field
from pydantic.dataclasses import dataclass

from ..utils.profile import BaseProfile, Profile
from .WindTurbineType3or4IEC import WindTurbineType3or4IEC


@dataclass
class WindTurbineType4IEC(WindTurbineType3or4IEC):
    """
    Parent class supporting relationships to IEC wind turbines type 4 including their control models.

    WindGenType3aIEC: Wind generator type 3A model associated with this wind turbine type 4 model.
    """

    WindGenType3aIEC: Optional[str] = Field(
        default=None,
        json_schema_extra={
            "in_profiles": [
                Profile.DY,
            ]
        },
    )

    @cached_property
    def possible_profiles(self) -> set[BaseProfile]:
        """
        A resource can be used by multiple profiles. This is the set of profiles
        where this element can be found.
        """
        return {
            Profile.DY,
        }
